<?php

/**
 * titulo_solicitud_cod_exped actions.
 *
 * @package    canon
 * @subpackage titulo_solicitud_cod_exped
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class titulo_solicitud_cod_expedActions extends sfQuery
{
 
     /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            
            $input=' ';
            if(isset ($request['input']))
            {
                $input="AND UPPER(codigo_expediente) LIKE UPPER('%".$request['input']."%')";  
            }
            
            $whereNotifica = ' ';
            if (isset($request['notifica'])) {
                if($request['notifica']==1)
                {
                    $whereNotifica = " and notifica = '" . $request['notifica'] . "' ";
                }
            }
            $data=' ';
            if (isset($request['data'])) {
                $data=$request['data'];
            }

            
            if($data!=-1)
            {
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
select * from(select distinct

case 
when tab0.cod_exp is null then tab1.id_solicitud
when tab1.codigo_expediente is null then null
else tab1.id_solicitud
end as id_solicitud,

case 
when tab0.cod_exp is null then tab1.codigo_expediente
when tab1.codigo_expediente is null then tab0.cod_exp
else tab0.cod_exp
end as codigo_expediente,

case 
when tab0.cod_exp is null then tab1.area_definitiva
when tab1.codigo_expediente is null then null
else tab1.area_definitiva
end as area_definitiva,

case 
when tab0.cod_exp is null then tab1.area_solicitada
when tab1.codigo_expediente is null then null
else tab1.area_solicitada
end as area_solicitada,

case 
when tab0.cod_exp is null then tab1.id_modalidad
when tab1.codigo_expediente is null then null
else tab1.id_modalidad
end as id_modalidad,

case 
when tab0.cod_exp is null then 1
when tab1.codigo_expediente is null then 0
else 1
end as notifica

from rmn_titulo tab0 full join rmn_solicitud tab1 on tab0.cod_exp=tab1.codigo_expediente)
where codigo_expediente is not null  $input $whereNotifica 
order by codigo_expediente 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
 select * from(select distinct

case 
when tab0.cod_exp is null then tab1.id_solicitud
when tab1.codigo_expediente is null then null
else tab1.id_solicitud
end as id_solicitud,

case 
when tab0.cod_exp is null then tab1.codigo_expediente
when tab1.codigo_expediente is null then tab0.cod_exp
else tab0.cod_exp
end as codigo_expediente,

case 
when tab0.cod_exp is null then tab1.area_definitiva
when tab1.codigo_expediente is null then null
else tab1.area_definitiva
end as area_definitiva,

case 
when tab0.cod_exp is null then tab1.area_solicitada
when tab1.codigo_expediente is null then null
else tab1.area_solicitada
end as area_solicitada,

case 
when tab0.cod_exp is null then tab1.id_modalidad
when tab1.codigo_expediente is null then null
else tab1.id_modalidad
end as id_modalidad,

case 
when tab0.cod_exp is null then 1
when tab1.codigo_expediente is null then 0
else 1
end as notifica

from rmn_titulo tab0 full join rmn_solicitud tab1 on tab0.cod_exp=tab1.codigo_expediente)
where codigo_expediente is not null $input $whereNotifica
order by codigo_expediente             
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('rmn_solicitud');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[TITULO_SOLICITUD_COD_EXPED] Consulta exitosa.");
            } else {

                $mensaje = "[TITULO_SOLICITUD_COD_EXPED] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
            }
            else {

                $mensaje = "[TITULO_SOLICITUD_COD_EXPED] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[TITULO_SOLICITUD_COD_EXPED] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }
    
    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
